


# add inundation dir to your pythonpath
from pmesh.mesh import Mesh
from coordinate_transforms.geo_reference import Geo_reference


def create_mesh(maximum_triangle_area,
                mesh_file=None,
                triangles_in_name = False):
    """
    triangles_in_name, if True is used to append the number of
    triangles in the mesh to the mesh file name.
    """
    # create a mesh instance of class Mesh
    m = Mesh()

    # Boundary of problem
    WidtH = 200 # width of boudary in metres
    #W = WidtH/8
    #L = W
    outer_polygon = [[0,0],[2*WidtH,0],[2*WidtH,WidtH],[0,WidtH]]
    print outer_polygon
    m.add_region_from_polygon(outer_polygon, tags={'wall':[0,1,2], 'wave':[3]})

    # inner polygons => building boundaries
    depth = 15 # depth of building side to oncoming wave
    wh = depth/2 
    breadth = 15 # breadth of building
    lh = breadth/2 
    print "building footprint"
    print depth * breadth , "m^2"
    block = 625
    BL = block**0.5
    print BL
    #[12.5,37.5,62.5,87.5,112.5,137.5,162.5,187.5]
    D = WidtH/2 + BL/2
    B = BL/2
    for D in [112.5,137.5,162.5,187.5]:
        for B in [12.5,37.5,62.5,87.5,112.5,137.5,162.5,187.5]:
            polygon = [[D-wh,B-lh],[D+wh,B-lh],[D+wh,B+lh],[D-wh,B+lh]]
            m.add_hole_from_polygon(polygon, tags={'wall':[0,1,2,3]})# Adds holes with reflective boundaries.        
            #print polygon
            
            print B

        print D

    m.generate_mesh(maximum_triangle_area=maximum_triangle_area)
    triangle_count = m.get_triangle_count()
    
    if mesh_file is None:    
        return m, triangle_count
    else:
        if triangles_in_name is True:
            mesh_file = mesh_file[:-4] + '_' + str(triangle_count) \
                        + mesh_file[-4:]
        m.export_mesh_file(mesh_file)
        return mesh_file, triangle_count

#-------------------------------------------------------------
if __name__ == "__main__":
    _, triangle_count = create_mesh(10,mesh_file="test.tsh")
    print "triangle_count",triangle_count 
